from ..core.element import RemoveProp
from ..elements.theme import theme_prop
from .input_element import InputElement
from .text import text
from .container import container
from .props import SizeProp, SizeProp, PositiveIntProp


class table_cell(container):
    # Props that the superclass supports but this class doesn't:
    grow = RemoveProp()
    shrink = RemoveProp()
    grid_area = RemoveProp()
    # Overridden prop:
    border = theme_prop("container_border")
    width = SizeProp("100%")
    height = SizeProp("100%")
    # New props:
    colspan = PositiveIntProp(1)
    rowspan = PositiveIntProp(1)

    def on_render(self, *label, **kwargs):
        # Render the label, if any, inside the cell
        if label:
            with self:
                text(*label)


class table_row(InputElement):
    is_container = True


class table_body(InputElement):
    is_container = True


class table_head(InputElement):
    is_container = True
    background_color = theme_prop("surface_color")


class table_foot(InputElement):
    is_container = True
    background_color = theme_prop("surface_color")


class table(InputElement):
    is_container = True
